#pragma once

#include <avr/io.h> 
#include <stdio.h>
#include <string.h>
#include <avr/pgmspace.h>

//delay function
#define F_CPU 7372800UL 		//Your clock speed in Hz (16MHz here)

#define LOOP_CYCLES 8 			//12	//Number of cycles that the loop takes


#define us(num) num

void delay_us(unsigned long delay);

#define PORT_ON( port_letter, number )			port_letter |= (1<<number)
#define PORT_OFF( port_letter, number )			port_letter &= ~(1<<number)
#define PORT_ALL_ON( port_letter, number )		port_letter |= (number)
#define PORT_ALL_OFF( port_letter, number )		port_letter &= ~(number)
#define FLIP_PORT( port_letter, number )		port_letter ^= (1<<number)
#define PORT_IS_ON( port_letter, number )		( port_letter & (1<<number) )
#define PORT_IS_OFF( port_letter, number )		!( port_letter & (1<<number) )

#define CLEAR_FLAG(y)		FLAGS&=~_BV(y)
#define SET_FLAG(y)		FLAGS|=_BV(y)
#define TOGGLE_FLAG(y)		FLAGS^=_BV(y)
#define FLAG_IS_SET(y)		(FLAGS & _BV(y))
#define FLAG_IS_CLEAR(y)	(~FLAGS & _BV(y))
#define CLEAR_BIT(x,y)		x&=~_BV(y)
#define SET_BIT(x,y)		x|=_BV(y)
#define TOGGLE_BIT(x,y)		x^=_BV(y)
#define SET_BIT_AS_IN(x,y)	x&=~_BV(y)
#define SET_BIT_AS_OUT(x,y)	x|=_BV(y)
#define SET_PORT_AS_IN(x)	x=0x00
#define SET_PORT_AS_OUT(x)	x=0xff
