#define F_CPU 8000000UL
//#include <stdlib.h>
//#include <stdint.h> 
//#include <string.h>
//#include <avr/iom8.h>
#include <avr/eeprom.h>
#include <util/delay.h>
#include <avr/interrupt.h>
#include "uart.h"
#include "globals.h"

#define Cint	1.08 //uf
//#define Cint	0.250 //uf
////////   Photodiode Hamamatsu S2387-1010R   ////////
#define nResp(y) (0.0856689*y-0.000350935*y*y+7.59366E-7*y*y*y-9.06755E-10*y*y*y*y+5.66415E-13*y*y*y*y*y-1.44695E-16*y*y*y*y*y*y-8.50112)

#define UART_BAUD_RATE 19200

//VARIABILI GLOBALI

/*///////
void adc_init(void){
// Activate ADC with Prescaler 128
 ADCSRA = _BV(ADEN) | _BV(ADPS0)  | _BV(ADPS1) | _BV(ADPS2);
}

uint16_t start_conversion(int ch){ 

	#define AV 30
	uint8_t i=0;
	uint16_t avgs=0;
	
	ADMUX = ch;	

	for(i=0;i<AV;i++){
		ADCSRA |= _BV(ADSC);					
		while (ADCSRA & _BV(ADSC)){}
		avgs+=ADCW;
	}
		
	return avgs/AV;
}

ISR(TIMER1_OVF_vect){	// 1 sec

static uint8_t conteggio=0;
static uint8_t frame=0;
static uint8_t zero=0;		
static uint16_t Offset;

	switch (frame){
		case 0: ////////////////////////////// FASE DI INTEGRAZIONE
			SET_BIT(PORTC,6);
			CLEAR_BIT(PORTC,5);
			frame++;
		break;
		case 1: ////////////////////////////// FASE DI MANTENIMENTO
			CLEAR_BIT(PORTC,6);
*////////			
			//Emax0= start_conversion(0) - Offset;
			//Emax = Emax0 * 0.00488*Cint/nResp(Limp)/5;
			/*
			if((bit_is_clear(PIND,3)) && (bit_is_clear(PIND,4)) && zero > 100){
				Offset = start_conversion(0)-Offset;
				zero = 0;
			}else{
				Emax = (start_conversion(0)-Offset) * 0.00488*Cint/nResp(Limp)/5;
				//Emax = start_conversion(0);
								
				if(Emax<0) Emax=0;
			}	
			*/
/*///////
			zero++;
			frame++;
		break;
		case 2: ////////////////////////////// FASE DI RESET
			SET_BIT(PORTC,6);
			frame=0;
		break;
	}

	TOGGLE_BIT(PORTB,3);
	if(conteggio < 200)
		conteggio++;
	else
		conteggio=0;

	if(bit_is_clear(PORTD,4)){
		uart_putc(conteggio);
	}
	
/************************************************************************************
	if(menu>20){ // && frame==2){
		//MENU//		
		if(bit_is_clear(PIND,2) && Limp < 1100){			
			if (JOG_MULTIPLIER < 10) {
				Limp++;
				JOG_MULTIPLIER++;
			}else if (JOG_MULTIPLIER > 9 && Limp < 1091){
				Limp+=10;
			}
		}
		if(bit_is_clear(PIND,3) && Limp > 350){			
			if (JOG_MULTIPLIER < 10) {
				Limp--;
				JOG_MULTIPLIER++;
			}else if (JOG_MULTIPLIER > 9 && Limp > 359){
				Limp-=10;
			}

		}
		if((bit_is_set(PIND,3)) && (bit_is_set(PIND,2))){
			JOG_MULTIPLIER = 0;
		}

		eeprom_write_block((const void*)&Limp, (void*)&SetLimp, sizeof(Limp));
		
		sprintf(riga1," %dnm  ",Limp);	
		//sprintf(riga2,"%dadcp ",Emax);
		sprintf(riga2,"%.3fuJ ",Emax);
		lcd_gotoxy(0,0);
		lcd_string(riga1);
		lcd_gotoxy(0,1);
		lcd_string(riga2);
		menu=0;
	}

	menu++;
************************************************************************************/
/*///////
	TCNT1 = 31250;
}






int main(void){

/************************************************************************************
	SET_BIT_AS_IN(DDRD,3); // Setto a 1 il pulsante NEXT
	SET_BIT(PORTD,3);
	SET_BIT_AS_IN(DDRD,2); //Setto a 1 il pulsante BACK
	SET_BIT(PORTD,2);
	SET_BIT_AS_OUT(DDRC,5); //reset
	SET_BIT(PORTC,5); // resettato
	SET_BIT_AS_OUT(DDRC,6); //hold
	CLEAR_BIT(PORTC,6); // mantiene il dato
/********************************* CONTROLLO TRASMISSIONE ***************************/
	SET_BIT_AS_OUT(DDRD,7);	// Imposto se metterlo in stand-by o in funzione
	SET_BIT(PORTD,7);	// 0 STAND-BY | 1 WORK
	SET_BIT_AS_IN(DDRD,4);	// Controllo se libero o occupato
	CLEAR_BIT(PORTD,4);	// 0 FREE | 1 BUSY
	SET_BIT_AS_OUT(DDRD,3);	// Imposto se pronto a scrivere o ricevere il dato
	CLEAR_BIT(PORTD,3);	// 0 READY | 1 NOT READY
/************************************************************************************/
	SET_BIT_AS_OUT(DDRB,3); // PROVVISORIO DATO
	CLEAR_BIT(PORTB,3); 
		
//	adc_init();
	uart_init(UART_BAUD_SELECT(UART_BAUD_RATE,F_CPU));
//	sei();

/*///////
	//configurazione timer/counter 1
	TIMSK1|=(1<<TOIE1);	//overflow vector
  	TCCR1B|=(1<<CS12);	//256 prescaler
 	TCNT1 = 31250;		// 1 sec
*///////
	while(1){}

	return 0;
}
